function [Simu] = Backward_Mixture(Simu)

taille = max(size(Simu.y));
dim_sn = size(Simu.etat_sig);
if(dim_sn(1,1)~=taille)
    sn = Simu.etat_sig';
    dim_sn = size(Simu.etat_sig);
else
    sn = Simu.etat_sig;
end

y = Simu.y;
if(Simu.nb_unc_mean==0)
   mu = mean(y); 
else
   mu = Simu.theta(1); 
end
eps = y-mu;
nb_post = dim_sn(2);
sigma_mixt = Simu.sigma_mixture;
P_mixt = Simu.P_mixture;
sigma_C = Simu.sigma;

N = max(size(sigma_mixt));
draw_mixt = zeros(taille,nb_post);
eta_without_lev = eps./sqrt(Simu.var_t_lev);
sigma_mixt_T = kron(sigma_mixt,ones(1,taille));
dens_mixt = zeros(N,taille);
for q=1:nb_post
    eta = eta_without_lev./sqrt(sigma_C(sn(:,q)));
    eta_sq = eta.^2;
    for z=1:N
       dens_mixt(z,:) = P_mixt(z)*exp(-0.5*log(2*pi*sigma_mixt(z)) - 0.5*eta_sq./(sigma_mixt_T(z,:)'))';
    end
    for t=1:taille
        prob = dens_mixt(:,t)/sum(dens_mixt(:,t));
        draw_mixt(t,q) = multinomialrnd(prob,rand());
    end
end

backward = zeros(taille,N);
for j=1:N
    backward(:,j) = sum(draw_mixt==j,2);
end
backward = backward/nb_post;
Simu.backward_mixt = backward;

