%Likelihood calculation - uses method from Calvet&Fisher 2004

function [LL,LLs,pi_mat] = FB_matlab(sigma,sigma_mixture,regime,eps,P,p_mixture,var_t)
 
T = length(eps);                       
pi_mat = zeros(T+1,regime);     
LLs = zeros(1,T);
pi_mat(1,:) = (1/regime)*ones(1,regime);

%*----------------------------------------------------------------------*
%*                        Likelihood algorithm                          *
%*----------------------------------------------------------------------*
% pa = (2*pi)^-0.5;
std_sigma = sqrt(sigma);
s = repmat(std_sigma',T,1);
for q=1:regime
   s(:,q) = s(:,q).*sqrt(var_t);
end


w_t = repmat(eps,1,regime);
% w_t = pa*exp( - 0.5.*((w_t./s).^2))./s; 
% w_t = w_t + 1e-16;

pa = (2*pi)^-0.5./s;
A = - 0.5.*((w_t./s).^2);

regime_mixture = max(size(sigma_mixture));
std_sigma_mixture = sqrt(sigma_mixture);
val_mixture = p_mixture./std_sigma_mixture;

s_mixture = repmat(sigma_mixture',T,1);
for q=1:regime
    z_t = repmat(A(:,q),1,regime_mixture);
    pa_t = repmat(pa(:,q),1,regime_mixture);
    w_t(:,q) = (pa_t.*exp(z_t./s_mixture))*val_mixture;
end
w_t = w_t + 1e-16;

for t=2:T+1          
    piA = (pi_mat(t-1,:)*P);
    
    
    
    C = (w_t(t-1,:).*piA); ft = sum(C);
    if ft == 0                      %This stop div by zero if probs are too low
        pi_mat(t,1) = 1;   
    else
        pi_mat(t,:) = C / ft; 
    end
    
    LLs(t-1) = log(dot(w_t(t-1,:),piA));
end 
    LL=-sum(LLs);
    if ~isfinite(LL)
        disp('Log-likelihood is inf. Probably due to all zeros in pi_mat.')
    end
end



