%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%% Replications of the FHMV RV results.
%%% Main file for estimating the FHMV process: MLE_hierarchical_HMM_model.m
%%% This file replicates the in-sample results documented in Table 2 and
%%% the out-of-sample results presented in Table 6.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
addpath('./Additional_functions');

cd('DATA')
load('DATA_HMM_PAPER_JULY_2016.mat'); 
cd ..


%%%%%%%%%%%%%% Estimation of the model -- In-sample results
nb_component = 10;
nb_component_mixture = 10;
LL_FHMV_RV1 = zeros(3,2);
parfor q=1:3
    [Simu_aide] = MLE_hierarchical_HMM_model(TS_RV(q).series(:,2:3),5,4,0);
    [Simu_aide] = MLE_hierarchical_HMM_model(TS_RV(q).series(:,2:3),nb_component_mixture,7,0,Simu_aide);
    [Simu_Gamma_Var(q)] = MLE_hierarchical_HMM_model(TS_RV(q).series(:,2:3),nb_component_mixture,nb_component,0,Simu_aide);
    
    [Simu_aide] = MLE_hierarchical_HMM_model(TS_RV(q).series(:,2:3),5,4,1);
    [Simu_aide] = MLE_hierarchical_HMM_model(TS_RV(q).series(:,2:3),nb_component_mixture,7,1,Simu_aide);
    [Simu_Gamma_Var_lev(q)] = MLE_hierarchical_HMM_model(TS_RV(q).series(:,2:3),nb_component_mixture,nb_component,1,Simu_aide);
    LL_FHMV_RV(q,:) = [Simu_Gamma_Var(q).dens Simu_Gamma_Var_lev(q).dens];
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Prediction -- Out-of-sample results
%%%%% Worth mentionning: takes time.
parfor q=1:3
   T = max(size(TS_RV(q).series(:,2:3)));
   nb_deb = T-3*252;
   [Simu_forecast_lev(q),Simu_HHMM_lev(q)] = compute_statistics_prediction(TS_RV(q).series(:,2:3),nb_deb,1);
   [Simu_forecast(q),Simu_HHMM(q)] = compute_statistics_prediction(TS_RV(q).series(:,2:3),nb_deb,0);
end



