%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%% Replications of the FHMV log-return results.
%%% Main file for estimating the FHMV process: MLE_hierarchical_HMM_model.m
%%% This file replicates the in-sample results documented in Table 1 and
%%% the out-of-sample results presented in Table 5.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
addpath('./Additional_functions');
cd('DATA')
load('DATA_HMM_PAPER_JULY_2016.mat'); 
cd ..

%%%%%%%%%%%%%% Estimation of the model -- In-sample results
nb_component = 10;
nb_component_mixt = 10;
LL_FHMV = zeros(3,2);
parfor q=1:3
    [Simu_aide] = MLE_hierarchical_HMM_model(TS(q).returns,5,4,0);
    [Simu_aide] = MLE_hierarchical_HMM_model(TS(q).returns,nb_component_mixt,7,0,Simu_aide);
    [Simu_F0(q)] = MLE_hierarchical_HMM_model(TS(q).returns,nb_component_mixt,nb_component,0,Simu_aide);
    
    [Simu_aide] = MLE_hierarchical_HMM_model(TS(q).returns,5,4,1);
    [Simu_aide] = MLE_hierarchical_HMM_model(TS(q).returns,nb_component_mixt,7,1,Simu_aide);
    [Simu_F0_L1(q)] = MLE_hierarchical_HMM_model(TS(q).returns,nb_component_mixt,nb_component,1,Simu_aide);
    LL_FHMV(q,:) = [Simu_F0(q).dens Simu_F0_L1(q).dens];
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Prediction -- Out-of-sample results
%%%%% Worth mentionning: takes time.
parfor q=1:3
   T = max(size(TS(q).returns));
   nb_deb = T-3*252;
   [Simu_forecast(q),Simu_HHMM(q)] = compute_statistics_prediction(TS(q).returns,nb_deb,0);
   [Simu_forecast_lev(q),Simu_HHMM_lev(q)] = compute_statistics_prediction(TS(q).returns,nb_deb,1);
end




