function [Simu] = backward_step(Simu)

forward = Simu.forward;
P = Simu.P;
states = Simu.sigma;

taille = size(forward,1); 
nb_states = max(size(states));
prob_back = zeros(taille,nb_states);

prob_back(end,:) = forward(end,:);
for t=taille-1:-1:1
    a = kron(forward(t,:)',ones(1,nb_states)).*P;
    b = kron(ones(nb_states,1),sum(a,1));
    c = a./b;
    prob_back(t,:) = (c*(prob_back(t+1,:)'))';
end

kbar = Simu.kbar;
[vect] = create_indicator_for_states(kbar);
prob_over_t_backward = zeros(taille,kbar);
for j=1:kbar
   ind = vect(j,:)==1;
   prob_over_t_backward(:,j) = sum(prob_back(:,ind),2);
end
Simu.prob_over_t_backward_exact = prob_over_t_backward;
Simu.backward_exact = prob_back;

