function [Simu_forecast,Simu_HHMM] = compute_statistics_prediction(y,deb_forecast,leverage)
if(nargin<3)
    leverage = 0;
end
distribution = 'Gamma';
disp('****** Prediction only available for the variance ******');
if(strcmp(distribution,'Gamma')==0 && strcmp(distribution,'IGamma')==0)
    disp('***** Distribution not available ****');
    disp('***** Note that predictions with log-logistic has not been implemented *****');
    distribution = 'Gamma';
end

nb_forecast = 100;
taille = max(size(y));
nb_iter = taille-deb_forecast +1;

nb_type_of_sigmas = 2;
RMSE = zeros(nb_forecast,nb_type_of_sigmas);
SE = zeros(nb_forecast,nb_iter,nb_type_of_sigmas);
count = zeros(nb_forecast,1);
Pred_LL = zeros(nb_iter,nb_type_of_sigmas);
Pred_CDF = zeros(nb_iter,nb_type_of_sigmas);
nb_kbar = 10;
all_forecast_sigma = zeros(nb_forecast,nb_type_of_sigmas,nb_iter); %%% Attention nb_forecast doit correspondre avec nb_forecast dans le programme MLE_hier...
gamma_param = zeros(nb_iter,2);

for q=1:nb_iter
    disp(['Iteration ' num2str(q) ' on ' num2str(nb_iter)]);
    ind_fin = deb_forecast+q-1;
    y_t = y(1:ind_fin,:);   
    %%%%% Hierarchical HMM
    if(q==1)
        [Simu_HHMM] = MLE_hierarchical_HMM_model(y_t,5,5,leverage);
        [Simu_HHMM] = MLE_hierarchical_HMM_model(y_t,nb_kbar,nb_kbar,leverage,Simu_HHMM);
        theta_MLE = zeros(max(size(Simu_HHMM.theta)),nb_iter);
    else
        [Simu_HHMM] = MLE_hierarchical_HMM_model(y_t,nb_kbar,nb_kbar,leverage,Simu_HHMM);
    end   
    theta_MLE(:,q) = Simu_HHMM.theta;
    all_forecast_sigma(:,:,q) = [Simu_HHMM.sigma_for_mean Simu_HHMM.sigma_for_median];
    gamma_param(q,:) = Simu_HHMM.dist_gamma_param;
end

for q=1:nb_iter
    ind_fin = deb_forecast+q-1;
    if(ind_fin+nb_forecast>taille)
       nb_pred = taille-ind_fin; 
    else
       nb_pred = nb_forecast; 
    end
    
    y_for_models = zeros(nb_pred,nb_type_of_sigmas);
    y_for_models(:,1) = cumsum(all_forecast_sigma(1:nb_pred,1,q)); 
    y_for_models(:,2) = cumsum(all_forecast_sigma(1:nb_pred,2,q)); 
    
    y_pred = cumsum(y(ind_fin+1:ind_fin+nb_pred,1));
    %%%%%%% RMSE
    for z=1:nb_type_of_sigmas
        RMSE(1:nb_pred,z) = RMSE(1:nb_pred,z) + (y_pred-y_for_models(:,z)).^2;
        SE(1:nb_pred,q,z) = (y_pred-y_for_models(:,z)).^2;
    end
    count(1:nb_pred) = count(1:nb_pred)+1;

    %%%%%%%% Predictive Log-likelihood
    if(nb_pred>0)
        for z=1:nb_type_of_sigmas
            x = y_pred(1)/y_for_models(1,z);
            if(strcmp(distribution,'IGamma'))
                Pred_LL(q,z) = gamma_param(q,1)*log(gamma_param(q,2)) -gammaln(gamma_param(q,1)) -(gamma_param(q,1)+1)*log(x) -gamma_param(q,2)/x -log(y_for_models(1,z));
                Pred_CDF(q,z) = gamcdf(1/y_pred(1),gamma_param(q,1),1/(y_for_models(1,z)*gamma_param(q,2))); %%%% Cela donne avec le Jacobien cette distribution.
            else
                Pred_LL(q,z) = -gamma_param(q,1)*log(gamma_param(q,2)) -gammaln(gamma_param(q,1)) +(gamma_param(q,1)-1)*log(x) -x/gamma_param(q,2) -log(y_for_models(1,z));
                Pred_CDF(q,z) = gamcdf(y_pred(1),gamma_param(q,1),y_for_models(1,z)*gamma_param(q,2)); %%%% Cela donne avec le Jacobien cette distribution.
            end
        end
    end
    
end
Simu_forecast.theta_MLE = theta_MLE;
%%%%%%% RMSE
for z=1:nb_type_of_sigmas
    RMSE(:,z) = RMSE(:,z)./count;
    RMSE(:,z) = sqrt(RMSE(:,z));
end
Simu_forecast.RMSE = RMSE;
Simu_forecast.SE_tab = SE;
Simu_forecast.all_forecast_sigma = all_forecast_sigma;
Simu_forecast.Pred_LL = Pred_LL(1:end-1,:);
Simu_forecast.Pred_CDF = Pred_CDF(1:end-1,:);