function [V_t,stat_dist] = filtered_V_t(Simu)

p_mixt = Simu.P_mixture;
sigma_mixt = Simu.sigma_mixture;
N_mixt = max(size(sigma_mixt));
etat_sig = Simu.etat_sig;
sigma = Simu.sigma;

T = max(size(Simu.y));
y = Simu.y;
nb_post = size(etat_sig,2);

gam_a = 1/Simu.gamma_param;
gam_b = Simu.gamma_param;


all_states = kron(sigma,sigma_mixt);
N_C = Simu.kbar;
stat_prob = kron(ones(2^(N_C),1)/2^(N_C),p_mixt);



V_t = zeros(T,nb_post);
sigma_aide = kron(sigma_mixt',ones(T,1));
p_mixt_aide = kron(p_mixt',ones(T,1));
for i=1:nb_post
    sigma_cur = sigma(etat_sig(:,i)).*Simu.var_t_lev;
    y_norm = y(:,1)./sigma_cur;
    a = kron(y_norm,ones(1,N_mixt))./sigma_aide;
    dens = -gammaln(gam_a) - gam_a*log(gam_b) + (gam_a-1)*log(a) -a/gam_b - log(kron(sigma_cur,ones(1,N_mixt)).*sigma_aide);
    prob = p_mixt_aide.*exp(dens);
    for t=1:T
       maxi = max(dens(t,:));
       prob = (exp(dens(t,:)-maxi)').*p_mixt;
       prob = prob/sum(prob);
       ind = multinomialrnd(prob,rand());
       V_t(t,i) = sigma_cur(t)*sigma_mixt(ind);
    end
end



nb_post = 5e5;
stat_dist = zeros(nb_post,1);
for i=1:nb_post
    ind = multinomialrnd(stat_prob,rand());
    stat_dist(i) = gamrnd(gam_a,gam_b*all_states(ind));
end