function [Simu] = inverse_tranform(Simu)

taille = max(size(Simu.y));
y = Simu.y;
if(Simu.nb_unc_mean==0)
   mu = mean(y); 
else
   mu = Simu.theta(1); 
end

sigma_mixt = Simu.sigma_mixture;
P_mixt = Simu.P_mixture;
sigma_C = Simu.sigma;
N = max(size(sigma_mixt));

forward = Simu.forward;
P = Simu.P;
P_current = forward*P;
var_t_lev = Simu.var_t_lev;

quantile_th = zeros(taille,1);
dim_C = size(P_current,2);

sigma = kron(sqrt(sigma_C),sqrt(sigma_mixt));
for t=2:taille
    prob = P_current(t-1,:)';
    P = kron(prob,P_mixt)';
    quantile_th(t) = P*normcdf(y(t)*ones(dim_C*N,1),mu*ones(dim_C*N,1),sigma*sqrt(var_t_lev(t))); %% Verif avec Simulation
end

draw_N = norminv(quantile_th(2:end));
[h_kol,p_kol] = kstest(draw_N);
[h_JB,p_JB] = kstest(draw_N);

Simu.goodness.JB_test.h_JB = h_JB;
Simu.goodness.JB_test.p_JB = p_JB;
Simu.goodness.kol_test.h_kol = h_kol;
Simu.goodness.kol_test.p_kol = p_kol;
Simu.goodness.quantile = quantile_th;



%%%%% Quantile avec Simulation
% nb_draw = 1e4;
% quantile = zeros(taille,1);
% parfor t=1:taille
%     draw_y = zeros(nb_draw,1);
%     if(mod(t,100)==0)
%         disp(['iteration : ' num2str(t) ' on ' num2str(taille)])
%     end
%     prob = P_current(t,:)';
%     for z=1:nb_draw
%         st = multinomialrnd(prob,rand());
%         st_mixt = multinomialrnd(P_mixt,rand());
%         draw_y(z) = mu + randn()*sqrt(sigma_C(st)*sigma_mixt(st_mixt)*var_t_lev(t));
%     end
%     quantile(t) = sum(sort(draw_y<y(t)))/nb_draw;
%     if(quantile(t)==0)
%         quantile(t) = 1/nb_draw;
%     elseif(quantile(t)==1)
%         quantile(t) = (nb_draw-1)/nb_draw;
%     end
% end