function [log_like,sn_sig,sigma,P,forward,theta_lev,var_t,val_theta_sigma,theta_P,val_lev_t,gamma_param,fct_leverage,P_kbar,P_mixture,sigma_mixture,time_eval] = launch_FB_sigma_MLE_for_hierarchical_HMM(y_t,taille,regime,kbar_mixture,theta,nb_param_sigma,kbar_leverage,gamma_dist,model_variance,nb_iter_back)
if(nargin<10)
    nb_iter_back = 0;
    if(nargin<9)
        model_variance = 1;
        if(nargin<8)
            gamma_dist = 0;
            if(nargin<7)
                kbar_leverage = 0;
            end
        end
    end
end
time_cur = tic;
if(max(size(theta))<3)
    error('probleme de dimension');
end

kbar = log(regime)/log(2);
if(mod(kbar,round(kbar))~=0)
    error('probleme de dimension');
end


%%
%%%% States of the high dimensional Markov-chain
nb_free_MS = nb_param_sigma-2-4;
if(gamma_dist==2)
    gamma_param = exp(theta(1))+1;
else
    gamma_param = exp(theta(1));
end
sigma_bar = exp(theta(2));
persistence = exp(theta(nb_param_sigma-1:nb_param_sigma))./(1+exp(theta(nb_param_sigma-1:nb_param_sigma)));
f_val = 1+exp(theta(3:4+nb_free_MS));
test = 1;
if(sum(f_val>10)~=0)
    test = 0;
end

%%%%%%%%%%%%%%%
[f_mixture] = autoregressive_midas(kbar_mixture-1,persistence(1),f_val(1));
[f_secondary] = autoregressive_midas(kbar-nb_free_MS,persistence(end),f_val(end));

f_secondary = [f_val(2:end-1);f_secondary];
sigma = [1 f_secondary(1)]';
for z=2:kbar
    aide = [1 f_secondary(z)]';
    sigma = kron(sigma,aide);
end
sigma = sigma_bar*sigma;
val_theta_sigma = [sigma_bar f_mixture' f_secondary' persistence'];

%%
%%%% T.P.M. of the High dimensional Markov-chain.
if(kbar_leverage~=0)
    nb_lev = 2;
else
    nb_lev = 0;
end

theta_P = theta(nb_param_sigma+1:end-nb_lev);
theta_P = exp(theta_P)./(1+exp(theta_P));
taille_P = max(size(theta_P));

if(taille_P>3+nb_free_MS)
    error('probleme de taille pour P');
end


regime_mixture = kbar_mixture;
sigma_mixture = [1;f_mixture];
P_mixture = ones(regime_mixture,1);
P_mixture(1) = theta_P(1);
P_mixture(2:end) = (1-theta_P(1))/(regime_mixture-1);

if(kbar_mixture == 0)
    P_mixture = 1;
    sigma_mixture = 1;
    regime_mixture = 1;
end

theta_P_MS = theta_P(2:end);
taille_P_MS = taille_P-1;
param_P_MS = zeros(kbar,2);
if(taille_P_MS==1)
    param_P_MS = ones(kbar,2)*theta_P_MS;
elseif(taille_P_MS==nb_free_MS+1)
    param_P_MS(:,1) = [theta_P_MS(1:nb_free_MS);ones(kbar-nb_free_MS,1)*theta_P_MS(end)];
    param_P_MS(:,2) = param_P_MS(:,1);
else
    if(taille_P_MS==nb_free_MS+2)
        param_P_MS(:,1) = [theta_P_MS(1:nb_free_MS);ones(kbar-nb_free_MS,1)*theta_P_MS(end-1)];
        param_P_MS(:,2) = [theta_P_MS(1:nb_free_MS);ones(kbar-nb_free_MS,1)*theta_P_MS(end)];
    else
        error('probleme dimension P');
    end
end
P = [param_P_MS(1,1) 1-param_P_MS(1,1);1-param_P_MS(1,2) param_P_MS(1,2)];
P_kbar = P;
for z=2:kbar
    P_kbar = [param_P_MS(z,1) 1-param_P_MS(z,1);1-param_P_MS(z,2) param_P_MS(z,2)];
    P =  kron(P,P_kbar);
end



%%
%%% Leverage effect component
var_t = ones(taille,1);
val_lev_t = ones(taille,1);
fct_leverage = 0;
if(kbar_leverage ~=0)
    eps_t = y_t(:,2) - mean(y_t(:,2));
    theta_lev = exp(theta(end-nb_lev+1:end))./(1+exp(theta(end-nb_lev+1:end)));
    moyenne = 1:70;%1:3*22;
    taille_moyenne = max(size(moyenne));
    val_lev_t = ones(taille,taille_moyenne);

    [fct_leverage] = autoregressive_midas(taille_moyenne,theta_lev(1),theta_lev(2),0);
    leverage_t = ones(taille,1);
    for j=1:taille
        nb_val = taille_moyenne;
        nb_out = 0;
        if(j<=taille_moyenne)
            nb_val = j-1;
            nb_out = taille_moyenne-nb_val;
        end
        eps_lev = [eps_t(j-1:-1:j-nb_val)./sqrt(leverage_t(j-1:-1:j-nb_val));zeros(nb_out,1)];
        ind = (eps_lev)<0;
        leverage_t(j) = prod(1+fct_leverage(ind).*abs(eps_lev(ind)));
        var_t(j) = leverage_t(j);
    end
else
    theta_lev = 0;
end
%%
%%% Likelihood estimation.
sn_sig = ones(taille,1);
if(sum(sigma>0)==max(size(sigma)) && test == 1)
    if(nb_iter_back==0 && regime>63)
        [log_like,~,forward] = FB_matlab_gamma(sigma,sigma_mixture,regime,y_t(:,1),P,P_mixture,var_t,gamma_param,gamma_dist,model_variance);
        log_like = -1*log_like;
    else
        
        if(gamma_dist==0)
            gamma_ln_alpha = gammaln(gamma_param+1);
        else
            gamma_ln_alpha = gammaln(1/gamma_param);
        end
        [sn_sig,log_like,forward] = FB_sigma_gamma_c(y_t(:,1),regime,sigma,P,rand(nb_iter_back*taille,1),1,var_t,nb_iter_back,sigma_mixture,P_mixture,regime_mixture,gamma_param,gamma_dist,gamma_ln_alpha,model_variance);
        sn_sig = round(sn_sig)+1;
    end
    if(isnan(log_like) || isinf(log_like))
        log_like = -1e17;
    end
else
   log_like = -1e17; 
end
time_eval = toc(time_cur);