function [MLE] = max_gamma_dist(y)


test = 0;
while(test==0)
    log_param = randn(2,1)*5;
    [log_like] = log_likelihood_gamma(y,log_param);
    if(isreal(log_like)==1 && isnan(log_like)==0 && isinf(log_like)==0)
        test = 1;
    end
end
option_unc = optimset('MaxIter',1e7,'MaxFunEvals',1e7,'Display','iter','FinDiffType','central');
[val_theta] = fminunc(@(log_gamma_param) -1*log_likelihood_gamma(y,log_gamma_param),log_param,option_unc);
MLE.log_like = log_likelihood_gamma(y,val_theta);
MLE.theta = exp(val_theta)';


end



function [log_like] = log_likelihood_gamma(y,log_gamma_param)

gamma_param = exp(log_gamma_param);
gam_a = gamma_param(1);
gam_b = gamma_param(2);

log_like = sum(-gammaln(gam_a) - gam_a*log(gam_b) + (gam_a-1)*log(y) -y/gam_b);
end
