function [Moments] = moments_of_the_model(y_t,regime,kbar_mixture,theta,nb_param_sigma,kbar_leverage,student_dist)


if(nargin<8)
    student_dist = 0;
    if(nargin<7)
        kbar_leverage = 0;
    end
end


if(max(size(theta))<3)
    error('probleme de dimension');
end

kbar = log(regime)/log(2);
if(mod(kbar,round(kbar))~=0)
    error('probleme de dimension');
end


sigma_bar = exp(theta(2));
persistence = exp(theta(nb_param_sigma-1:nb_param_sigma))./(1+exp(theta(nb_param_sigma-1:nb_param_sigma)));
f_val = 1+exp(theta(3:4));%./(1+exp(theta(3:4)));%sort(1+exp(theta(3:3+kbar_main)));
test = 1;
if(sum(f_val>10)~=0)
    test = 0;
end
[f_mixture] = autoregressive_midas(kbar_mixture,persistence(1),f_val(1));
% f_mixture = f_val(1)*ones(kbar_mixture,1);
[f_secondary] = autoregressive_midas(kbar,persistence(end),f_val(end));

if(kbar_leverage~=0)
    nb_lev = 2;
else
    nb_lev = 0;
end
if(student_dist==1)
    nb_stud = 1;
else
    nb_stud = 0;
end
theta_P = theta(nb_param_sigma+1:end-nb_lev-nb_stud);
theta_P = exp(theta_P)./(1+exp(theta_P));
taille_P = max(size(theta_P));
if(taille_P>3)
    warning('probleme de taille pour P');
end

% [P_mixture] = autoregressive_midas(kbar_mixture,persistence(1),1+theta_P(1));
% P_mixture = P_mixture-1;
P_mixture = ones(kbar_mixture,1)*theta_P(1);
P_mixture = [P_mixture(1);1-P_mixture(1)];
for q=2:kbar_mixture
    aide_mixture = [P_mixture(q);1-P_mixture(q)];
    P_mixture = kron(P_mixture,aide_mixture);
end


if(taille_P<=2)
   P = [theta_P(end) 1-theta_P(end);1-theta_P(end) theta_P(end)]; 
else
   P = [theta_P(end-1) 1-theta_P(end-1);1-theta_P(end) theta_P(end)];
end
P_kbar = P;

for z=2:kbar
    P =  kron(P,P_kbar);
end

%%% Correction
% Exp_F = prod(pi_1./f_secondary + pi_2.*f_secondary);
% sigma = sigma/Exp_F;



% eps_t = y_t-theta(1);
% var_t = ones(taille,1);
% val_lev_t = ones(taille,1);
% fct_leverage = 0;
% if(kbar_leverage ~=0)
%     error('pas encore fait')
%     theta_lev = exp(theta(end-nb_lev-nb_stud+1:end-nb_stud))./(1+exp(theta(end-nb_lev-nb_stud+1:end-nb_stud)));
%     moyenne = 1:3*22;
%     taille_moyenne = max(size(moyenne));
%     val_lev_t = ones(taille,taille_moyenne);
%     [fct_leverage] = autoregressive_midas(taille_moyenne,theta_lev(1),1+theta_lev(2));
% 
%     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    
%     eps_lev = zeros(taille,1);
%     for j=1:taille_moyenne
%         eps_lev(1:j) = 0;
%         eps_lev = eps_lev + [zeros(j,1);eps_t(1:taille-j)];
%         ind = (eps_lev/j)<0;
%         val_lev_t(ind) = fct_leverage(j);
%         var_t(ind) = var_t(ind)*(fct_leverage(j));
%     end
%    
% else
%     theta_lev = 0;
% end
% df = 100;
% sn_sig = ones(taille,1);


p1 = P_kbar(1,1);
p2 = P_kbar(2,2);
pi_1 = (1-p2)/(2-p1-p2);
pi_2 = (1-p1)/(2-p1-p2);


nb_corr = 200;
Q = zeros(kbar,1);
% Q1 = zeros(kbar,1);
for q=1:kbar
    Q(q) = pi_1*pi_2*(f_secondary(q)^2-1)^2/(pi_1+pi_2*f_secondary(q)^2)^2;
%     Q(q) = (pi_1/f_secondary(q)^2 + pi_2*f_secondary(q)^2)/(pi_1/f_secondary(q) + (pi_2)*f_secondary(q))^2;
end

Q_mixture = zeros(kbar_mixture,1);
for q=1:kbar_mixture
   Q_mixture(q) = (theta_P(1)/f_mixture(q)^2 + (1-theta_P(1))*f_mixture(q)^2)/(theta_P(1)/f_mixture(q) + (1-theta_P(1))*f_mixture(q))^2;
end

gamma = p1+p2-1;
corr_th = zeros(nb_corr,1);
for q=1:nb_corr
    corr_th(q) = (prod(Q*(gamma^q) +1) -1)/(3*prod(Q_mixture)*prod(Q+1)-1); %% normal que le traitement mixt soit diffrent. 
end
[corr_emp] = autocorr((y_t-theta(1)).^2,nb_corr);

Moments.corr_emp = corr_emp(2:end);
Moments.corr_th = corr_th;