function [Simu_HMM] = prediction_hierarchical_HMM(Simu_HMM,nb_forecast)
nb_unc_var = 252;
sigma_for = zeros(nb_forecast,1);
P = Simu_HMM.P;
p_mixt = Simu_HMM.P_mixture;
sigma = Simu_HMM.sigma;
sigma_mixt = Simu_HMM.sigma_mixture;
E_mixt = p_mixt'*sigma_mixt;
pred =  Simu_HMM.forward(end,:);
y = Simu_HMM.y;
distribution = Simu_HMM.distribution;
switch distribution
    case 'IGamma'
        gamma_dist = 0;
    case 'Log-Logistic'
        gamma_dist = 2;
    otherwise
        gamma_dist = 1;
end
param_dist = Simu_HMM.dist_gamma_param;


kbar_leverage = Simu_HMM.kbar_leverage;
fct_leverage = Simu_HMM.fct_leverage;
if(kbar_leverage~=0)
   nb_MC = 1e4;
   MC_sigma = zeros(nb_MC,nb_forecast);
   mu = mean(y(:,2));
   eps_t_parfor =  y(end:-1:end-kbar_leverage+1,2)-mu;
   last_returns = y(end-nb_unc_var+1:end,2);
   var_t_ret = var(last_returns);
   leverage_t = Simu_HMM.var_t_lev;
   last_leverage = leverage_t(end:-1:end-kbar_leverage+1);

   parfor i=1:nb_MC
       last_leverage_parfor = last_leverage;
       window_eps_t = eps_t_parfor;
       ind = window_eps_t<0;
       var_t_lev = ones(kbar_leverage,1);
       var_t_lev(ind) = 1+fct_leverage(ind).*abs(window_eps_t(ind)./sqrt(last_leverage_parfor(ind)));
       
       
       prediction_sigma = zeros(1,nb_forecast);
       s_t = multinomialrnd(pred,rand());
       
       for q=1:nb_forecast
           s_t = multinomialrnd(P(s_t,:),rand());
           s_t_mixt = multinomialrnd(p_mixt,rand());
           last_leverage_parfor = [1;last_leverage_parfor(1:end-1)];
           last_leverage_parfor(1) = prod(var_t_lev);
           prediction_sigma(q) = sigma_mixt(s_t_mixt)*sigma(s_t)*last_leverage_parfor(1);
           if(gamma_dist==0)
               eps_current = prediction_sigma(q)/gamrnd(param_dist(1),1/param_dist(2));
           else
               eps_current = gamrnd(param_dist(1),param_dist(2))*prediction_sigma(q);
           end
           prediction_sigma(q) = eps_current;
           %%%%%% Prdiction des rendements en supposant une variance sur
           %%%%%% les 252 dernires donnes (cela donne une variance
           %%%%%% constante).
           ret_fut = randn()*sqrt(var_t_ret);
           window_eps_t = [ret_fut;window_eps_t(1:end-1)];
           ind = window_eps_t<0;
           var_t_lev = ones(kbar_leverage,1);
           var_t_lev(ind) = 1+fct_leverage(ind).*abs(window_eps_t(ind)./sqrt(last_leverage_parfor(ind)));
       end
       MC_sigma(i,:) = prediction_sigma;
   end
   sigma_for = mean(MC_sigma)';
   sigma_for_median = median(MC_sigma)';
else
   for q=1:nb_forecast
       pred = pred*P;
       sigma_for(q) =pred*sigma*E_mixt;
   end
   sigma_for_median = sigma_for;
end
Simu_HMM.sigma_for_mean = sigma_for;
Simu_HMM.sigma_for_median = sigma_for_median;
Simu_HMM.sigma_for = sigma_for;